/***************************************************************************
// figurka.h: interface for the figurka class.
//
    copyright            : (C) 2002 by Peter Kuk
    email                : kutak@stonline.sk
 ***************************************************************************/

#ifndef FIGURKA_H
#define FIGURKA_H

#ifdef mbeh_data_dir
#	define data_dir mbeh_data_dir
#endif

#ifndef data_dir
#define data_dir ""
#endif

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include <SDL/SDL.h>
#include "mbeh_struktury.h"


class figurka  
{
public:
	figurka();
	virtual ~figurka();
	Uint16 rychlost;
	Uint8 pohybLeft, pohybRight, pohybUp, pohybDown;
	Sint16 pohybX;
	Sint16 pohybY;
	RGB_farba farba;
	RGB_farba Hfarba;
	pozicia poziciaX;
	pozicia poziciaY;
	figurkaHra hra;
	SDLKey k_left;
	SDLKey k_right;
	SDLKey k_up;
	SDLKey k_down;
	int body;
	SDL_Surface *animobr(bool next=true);
	void sadniSi();
	static RGB_farba stdFarby[4];
	static RGB_farba stdHFarby[4];
	static int nahrajObrazky();
protected:
	int nicneroby;
	int sadnutsi;
	int sedi;
	int sadnut;
	SDL_Surface* lastanimobr;
	int anim;//cislo pre animaciu
	int tanim;//typ animacie v pedoslom animobr()
	static int dalsiafarba;
	static bool obrSuNahrate;
	static SDL_Surface* tc1;
	static SDL_Surface* tc2;
	static SDL_Surface* tc3;
	static SDL_Surface* tc4;
	static SDL_Surface* tc5;
	static SDL_Surface* tl1;
	static SDL_Surface* tl2;
	static SDL_Surface* tl3;
	static SDL_Surface* tl4;
	static SDL_Surface* tl5;
	static SDL_Surface* tp1;
	static SDL_Surface* tp2;
	static SDL_Surface* tp3;
	static SDL_Surface* tp4;
	static SDL_Surface* tp5;
	static SDL_Surface* tv1;
	static SDL_Surface* tv2;
	static SDL_Surface* tv3;
	static SDL_Surface* tv4;
	static SDL_Surface* tv5;
	static SDL_Surface* tcl1;
	static SDL_Surface* tcl2;
	static SDL_Surface* tcl3;
	static SDL_Surface* tcl4;
	static SDL_Surface* tcl5;
	static SDL_Surface* tcp1;
	static SDL_Surface* tcp2;
	static SDL_Surface* tcp3;
	static SDL_Surface* tcp4;
	static SDL_Surface* tcp5;
	static SDL_Surface* tvl1;
	static SDL_Surface* tvl2;
	static SDL_Surface* tvl3;
	static SDL_Surface* tvl4;
	static SDL_Surface* tvl5;
	static SDL_Surface* tvp1;
	static SDL_Surface* tvp2;
	static SDL_Surface* tvp3;
	static SDL_Surface* tvp4;
	static SDL_Surface* tvp5;
	static SDL_Surface* ts;
	static SDL_Surface **tca[8];
	static SDL_Surface **tva[8];
	static SDL_Surface **tla[8];
	static SDL_Surface **tpa[8];
	static SDL_Surface **tcla[8];
	static SDL_Surface **tcpa[8];
	static SDL_Surface **tvla[8];
	static SDL_Surface **tvpa[8];
};

#endif	//FIGURKA_H 
 
