/***************************************************************************
                          main.cpp  -  description
                             -------------------
    begin                : So jl 27 09:44:07 CEST 2002
    copyright            : (C) 2002 by Peter Kuk
    email                : kutak@stonline.sk
 ***************************************************************************/


#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

//#include <iostream.h>
//#include <iso646.h> //logicke operatory slovne //blbost nie je to portovatelne? kaslem na to
#include <locale.h>
#include <stdlib.h>
#include <string.h>
#include <SDL/SDL.h>
//#include <SDL/SDL_draw.h> //treba upravit elipsy >>>> prilis rozsiahla zmena radsek pouzijem gfx :-(
#include <SDL_gfxPrimitives.h>//ved to kresly take hnusne elipsy, ze sa ani neda povedat, a ktomu este kazdu inu
#include "moje_i18n.h"
#include "moje_sdlfunc.h"
#include "mbeh.h"
#include "mbeh_struktury.h"
#include "mbeh_funkcie.h"
#include "mbeh_zvuky.h"
#include "figurka.h"

//#include "sponzor.h"
#ifdef SPONZOR
#	ifdef _WIN32
//#include <process.h>
#		include <windows.h>
#		include <shellapi.h>
#	endif //win32
#endif //SPONZOR


#ifndef PACKAGE	//nazov prekladoveho katalogu
#define PACKAGE "mbeh"
#endif

//SDL_Surface *lp;
//SDL_Surface *pozadie;
SDL_Surface *obr_celepozadie;
SDL_Surface *obr_zmrzlinaA;
SDL_Surface *obr_zmrzlinaB;
SDL_Surface *obr_zmrzlinaC;
SDL_Surface *obr_zmrzlinaV;
SDL_Surface *obr_nanuk;
//SDL_Surface *obr_spomalenie;
//SDL_Surface *obr_podkriz;
Mix_Chunk *ham;
SDL_Joystick *joyA;
SDL_Joystick *joyB;
bool joyAopen=false,joyBopen=false;
pause_prikaz pauzaVhre;//premenna signalizujuca ci je hra pauznuta
obtiaznost_hry obtiaznost=obtiaz_default;

void naKoniec(void)
{
/*	//TODO: ked kompilujem pomocou bcc32 tak kod v tejto funkcii vygenereju niekedy chybu kernelu ktovie preco, mozno closeAudio alebo co? chyba nie je vzdy
	//      mozno ze to nie je kod tejto funkcie ale proste nieco na konci programu (co vklada bcc)
	Mix_FadeOutMusic(2000);
	//TODO: 
	//uzatvori otvorene joysticky - mozno to nie je potrebne ale kto vie?
	if(joyAopen) 
	{
		SDL_JoystickClose(joyA);;
	};
	if(joyBopen)
	{
		SDL_JoystickClose(joyB);;
	};
	Mix_CloseAudio();//TODO? v rsim som to mal zablokovane, ktovie preco??
	SDL_VideoQuit();*/
	SDL_Quit();
};


void pause(pause_prikaz co=pause_flip)
{
//TODO? mozno by bolo lepsie pauzu riesti cez stavHry, ale neviem ako by to bolo s obnovenim tejto premennej po pauze, asi by sa musela vytvorit premenna ktora by ucovavala povodny stav premennej
// ale to by sposobit nesprave prekreslovanie obrazovky, co by sa muselo opravovat?
	if(co==pause_flip)
	{
		if(pauzaVhre==pause_run)
		{
			pauzaVhre=pause_stop;
		}else
		{
			pauzaVhre=pause_run;
		}

	}else
	{
		pauzaVhre=co;
	}
};

int main(int argc, char *argv[])
{
	zvukyAno=true;//pokusim sa inicializovat zvuky(ak to nezakazem z prikazoveho riadku)
	Uint32 videoflags=0;
	while(argc>1)
	{
		argc--;
		if(strcmp(argv[argc],"--fullscreen")==0 || strcmp(argv[argc],"-f")==0)
//		if(strstr(argv[argc],"fullscreen"))
		{
			videoflags|=(Uint32)(SDL_FULLSCREEN);
		}else
		if(strcmp(argv[argc],"--withoutsound")==0 || strcmp(argv[argc],"-s")==0)
		{
			zvukyAno=false;
		}else if(strstr(argv[argc],"--level")==argv[argc])
		{
			obtiaznost = (obtiaznost_hry) (argv[argc][7]-'0');
		}else if( strstr(argv[argc],"-l")==argv[argc])
		{
			obtiaznost = (obtiaznost_hry) (argv[argc][2]-'0');
		}else
//		if(strcmp(argv[argc],"--help")==0 || strcmp(argv[argc],"-h")==0 || strcmp(argv[argc],"/?")==0)
		{
			printf(i18n("Game Pingu`s run.\n"));
			printf(i18n("Copyright Peter Kutak 2002.\n"));
			printf("\n\tsyntax: %s [-lX | --levelX] [-f | --fullscreen] [-s | --withoutsound]\n",argv[0]);
			printf(i18n("\n\tfullscreen    run game in fullscreen mode"));
			printf(i18n("\n\twithoutsound  run game without sound efects"));
			printf(i18n("\n\t              (usable by problems with audio initializing)"));
			printf(i18n("\n\tlevelX        run game in difficult level %d-%d (default %d)"),obtiaz_min,obtiaz_max,obtiaz_default); 
			return EXIT_SUCCESS;
		}
	}
	//ak je parametramy nastavena niaka nezmyselna obtiaznot
	if(obtiaznost<obtiaz_min || obtiaznost>obtiaz_max)
	{
		obtiaznost=obtiaz_default;
	}

//	setlocale (LC_CTYPE, "");
//	setlocale (LC_MESSAGES, "");
	setlocale (LC_ALL, ""); // nastavy vsetky locale na krajinu nastavenu premennymi prostredia
	bindtextdomain (PACKAGE, LOCALEDIR);
	textdomain (PACKAGE);
	setlocale (LC_ALL, "C");//locale moze byt zmenene na standard C aby sa vsetko zobrazovalo standardne
	srand((unsigned)time(NULL));

	SDL_Surface *screen;
	SDL_Joystick *joyA;
	SDL_Joystick *joyB;

	figurka *Panacik[Max_Hracov];
	zTag bufferZ[Max_Objektov];//pole pre vzdialenost figuriek a predmetov na ploche ( Z buffer )
	Uint32 FarbyHracov[Max_Hracov];
	Uint32 FarbyHracovH[Max_Hracov];
	predmet predmety[Max_Predmetov];
//	bool nahanaSa=true;//false;
	unsigned char nahana=0;
	akystav stavHry=stav_uvod;
	m_kruh uvodnykruh;
	int posunutiey;
	int hraPanacikov=Max_Hracov;
	//SDL_Surface* podkriz[Max_Hracov];
	//Zmenil som na 44k/16 mozno to pomoze pod linuxom pri spustani s esd
	//TODO? pri hrani zvuku niekedy primiesava chrcanie lebo poskodzuje zvuk ? asi poskodi chunk alebo hra aj nieco co nema hrat alebo nedostatok systemoveho casu alebo co?
	int audio_rate = 22050;//44100;//
	Uint16 audio_format = AUDIO_S8;//AUDIO_S16;//
	int audio_channels = 2;
	int reakcnaDoba=3;//doba po ktorej reaguje na zmeny
	//vzdialenost v bodoch do ktorej registruje
	// x hracich policiek
	int reakcnaVzdialenost=(1<<PPO_DETAIL)*5;

	Uint32 t=0;
//	static Uint32 t=SDL_GetTicks();
//		printf("gt %d\n", SDL_GetTicks() );
//		printf("t %d\n", t );

	


	VecPolicka policko[Max_Policiek][Max_Policiek];
	for(int a=0;a<Max_Policiek;a++)
		for(int b=0;b<Max_Policiek;b++)
		{
			policko[a][b]=prazdne_policko;
		}

	
//	pocethracov = (PanacikA.hra?1:0)+(PanacikB.hra?1:0)+(PanacikC.hra?1:0)+(PanacikD.hra?1:0);

	SDL_Event event;
	int quit = 0;

	//inicializuje generator nahodnych cisiel
	srand((unsigned int)time((time_t *)NULL));

	/* Initialise SDL */
	if( SDL_Init( SDL_INIT_VIDEO | SDL_INIT_JOYSTICK | SDL_INIT_NOPARACHUTE ) < 0)
	{
		fprintf( stderr, i18n("Could not initialise SDL: %s\n"), SDL_GetError() );
		return EXIT_FAILURE;
	}

	//ked kompilujem pomocou bcc tak SDL_Init vynuluje casovac
	t=SDL_GetTicks();

	
	atexit(naKoniec);
	SDL_WM_SetCaption(i18n("Pingu`s run"), NULL);
	
	screen=SDL_SetVideoMode( 640, 480, 0, videoflags);
	if( !screen )
	{
		fprintf( stderr, i18n("Could not set video mode: %s\n"), SDL_GetError() );
//		SDL_Quit();
		return EXIT_FAILURE;
	}

//#ifdef WIN32	
if(zvukyAno)
{//ak sa mam pokusat inicializovat zvuk(parameter prikazoveho riadka....)
//TODO: nefunguje to s ESD!!! ani ked zvukovka nepouzivana - len to chrci
//TODO: ak je zvukovka pozivana spusti esd a program sa spusti ale bez zvukov druhy krat to uz zamrzne
//TODO: v linuxe ak je obsadena zvukovka sposobuje pokus o jej otvorenie niekedy az zastavenie programu
//      s tym WIN_32 som si nie isty?
	fprintf(stdout, i18n("Opening audio device.\n"));
	fprintf(stdout, i18n("If system do not respond long time use parameter -s.\n"));
	if(Mix_OpenAudio(audio_rate, audio_format, audio_channels, 512/*4096*/)<0)
	{
		fprintf(stdout, i18n("Couldn't open audio: %s\n"),SDL_GetError());
		zvukyAno=false;
	}else
	{
		fprintf(stdout, i18n("Audio device was opened.\n"));
		zvukyAno=true;
	}
}
//#endif

	if(zvukyAno)
	{
	static Mix_Music * uvodMus = NULL;
		uvodMus=Mix_LoadMUS(mbeh_data_dir"entertnr.mid");

		if(uvodMus) Mix_PlayMusic(uvodMus,-1);
//		Mix_VolumeMusic(32);//ved to nefunguje, aspon vo WIN32
	}

	//otvori joysticky
//	for(int jn=0; jn<SDL_NumJoysticks(); jn++)
//	{
//		if(jn>1) break;//maximalne 2 joysticky (0,1)
//	};
	if(joyA=SDL_JoystickOpen(0)) 
	{
		joyAopen=true;
	};
	if(joyB=SDL_JoystickOpen(1))
	{
		joyBopen=true;
	};

	SDL_ShowCursor(SDL_DISABLE);	//schova kurzor

	posunutiey = screen->h - (Max_Policiek*(VELKOST_POLICKA/2));
	//TODO: toto je len taka pomocka by neboli figurky na dolnom okraji co sposobuje havarie programu
	//posunutiey -=16;
//	Draw_Init();
	if(nahrajObrazky()) {fprintf(stderr, i18n("Graphic files could not be loaded!\n")); exit(EXIT_FAILURE);};
	if(zvukyAno)

	{
		if(nahrajZvuky()) {fprintf(stderr, i18n("Sound files could not be loaded!\n")); exit(EXIT_FAILURE);};
	}
	if(figurka::nahrajObrazky()) {fprintf(stderr, i18n("Graphic files could not be loaded!\n")); exit(EXIT_FAILURE);};

	for (int f=0 ;f<Max_Hracov;f++)
	{
		Panacik[f]=new figurka;		
	}


zaciatokNovejHry:	//tu sa nastavia vsetky premenne //TODO: chcelo by to nieco ine ako goto!?!?!
	//nastav uvodne hodnoty
	for (int i=0 ;i<Max_Hracov;i++)
	{
		FarbyHracov[i]=SDL_MapRGB(screen->format, Panacik[i]->farba.r,Panacik[i]->farba.g,Panacik[i]->farba.b);
		FarbyHracovH[i]=SDL_MapRGB(screen->format, Panacik[i]->Hfarba.r,Panacik[i]->Hfarba.g,Panacik[i]->Hfarba.b);
//		podkriz[i]=colorizuj(obr_podkriz,Panacik[i]->farba);
		Panacik[i]->hra=clovek;
		Panacik[i]->body=0;
		Panacik[i]->pohybDown=false;
		Panacik[i]->pohybUp=false;
		Panacik[i]->pohybLeft=false;
		Panacik[i]->pohybRight=false;
		Panacik[i]->rychlost=16;
		switch(i)
		{
		case 0:			
			Panacik[i]->k_left = SDLK_LEFT;
			Panacik[i]->k_right = SDLK_RIGHT;
			Panacik[i]->k_up = SDLK_UP;
			Panacik[i]->k_down = SDLK_DOWN;
			Panacik[i]->poziciaX.hodnotaPolicko.policko=0;
			Panacik[i]->poziciaY.hodnotaPolicko.policko=0;
			Panacik[i]->poziciaY.hodnotaPolicko.detail=STRED_POLICKA;
			Panacik[i]->poziciaX.hodnotaPolicko.detail=STRED_POLICKA;
			break;
		case 1:			
			Panacik[i]->k_left = SDLK_s;
			Panacik[i]->k_right = SDLK_f;
			Panacik[i]->k_up = SDLK_e;
			Panacik[i]->k_down = SDLK_d;
			Panacik[i]->poziciaX.hodnotaPolicko.policko=Max_Policiek-1;;
			Panacik[i]->poziciaY.hodnotaPolicko.policko=Max_Policiek-1;;
			Panacik[i]->poziciaY.hodnotaPolicko.detail=STRED_POLICKA;
			Panacik[i]->poziciaX.hodnotaPolicko.detail=STRED_POLICKA;
			break;
		case 2:
			Panacik[i]->k_left = SDLK_j;
			Panacik[i]->k_right = SDLK_l;
			Panacik[i]->k_up = SDLK_i;
			Panacik[i]->k_down = SDLK_k;
			Panacik[i]->poziciaX.hodnotaPolicko.policko=Max_Policiek-1;;
			Panacik[i]->poziciaY.hodnotaPolicko.policko=0;
			Panacik[i]->poziciaY.hodnotaPolicko.detail=STRED_POLICKA;
			Panacik[i]->poziciaX.hodnotaPolicko.detail=STRED_POLICKA;
			break;
		case 3:
			Panacik[i]->k_left = SDLK_KP4;
			Panacik[i]->k_right = SDLK_KP6;
			Panacik[i]->k_up = SDLK_KP8;
			Panacik[i]->k_down = SDLK_KP5;
			Panacik[i]->poziciaX.hodnotaPolicko.policko=0;
			Panacik[i]->poziciaY.hodnotaPolicko.policko=Max_Policiek-1;;
			Panacik[i]->poziciaY.hodnotaPolicko.detail=STRED_POLICKA;
			Panacik[i]->poziciaX.hodnotaPolicko.detail=STRED_POLICKA;
			break;
		}
	}


	//vynuluj vsetky predmety
	for(int jp=0; jp<Max_Predmetov;jp++)
	{
		predmety[jp].end();
	}

		
	// na uvod umiestni velku zmrzlinu do stredu
	//pridajPredmet(predmety,Max_Policiek/2,Max_Policiek/2,1,zmrzlinaV);
	predmety[0].aky=predmet_zmrzlinaV;
	predmety[0].timeleft=1;
	predmety[0].poziciaX.hodnotaPolicko.policko=Max_Policiek/2;
	predmety[0].poziciaY.hodnotaPolicko.policko=Max_Policiek/2;
	if(Max_Policiek%2)
	{
	predmety[0].poziciaX.hodnotaPolicko.detail=STRED_POLICKA;
	predmety[0].poziciaY.hodnotaPolicko.detail=STRED_POLICKA;
	}else
	{
	predmety[0].poziciaX.hodnotaPolicko.detail=0;
	predmety[0].poziciaY.hodnotaPolicko.detail=0;
	}
	
	(m_bod &)uvodnykruh=(m_bod &)predmety[0];
	uvodnykruh.polomer=VELKOST_POLICKA*Max_Policiek/3;
	stavHry=stav_uvod;
	pauzaVhre=pause_run;
	hraPanacikov=Max_Hracov;	


//  SDL_Rect clip;
//	SDL_GetClipRect(screen,&clip);
//	clip.x=100;
//	clip.y=100;
//	clip.w=100;
//	clip.h=100;
//	SDL_SetClipRect(screen,&clip);



  Uint32 c_black = SDL_MapRGB(screen->format, 0,0,0);
  Uint32 c_white = SDL_MapRGB(screen->format, 255,255,255);
  Uint32 c_gray = SDL_MapRGB(screen->format, 200,200,200);
  Uint32 c_dgray= SDL_MapRGB(screen->format, 64,64,64);
  Uint32 c_cyan = SDL_MapRGB(screen->format, 32,255,255);
  Uint32 c_red = SDL_MapRGB(screen->format, 255,0,0);
  Uint32 c_green = SDL_MapRGB(screen->format, 0,255,0);
  Uint32 c_blue = SDL_MapRGB(screen->format, 0,0,255);
  Uint32 c_yellow = SDL_MapRGB(screen->format, 255,255,0);
  Uint32 c_obloha = SDL_MapRGB(screen->format, 127,127,255);
  Uint32 c_policko = SDL_MapRGB(screen->format, 217,200,140);
  Uint32 c_ramik = SDL_MapRGB(screen->format, 203,187,131);

	while( !quit )
	{
		while( SDL_PollEvent( &event ) )
		{
			switch( event.type )
			{
			//TODO: ak za panacika hra pocitac tak hra pocitac a neprima prikazi z klavesnice
				case SDL_KEYDOWN:
					{
					const SDLKey sk=event.key.keysym.sym;
					switch( event.key.keysym.sym )
					{
/*						case SDLK_s:
							{//TODO: TOTO je pokus treba odstranit
								char *a[3];
								a[0]="potomok";
								a[1]="sponzor.htm";
								a[2]=NULL;

					ShellExecute(NULL, "explore", "c:\\", NULL, NULL, SW_SHOWNORMAL);
 								int r=_spawnl(_P_WAIT, "c:\\windows\\command\\start.exe","start.exe", "sponzor.htm", NULL );
//								int r=_spawnv(_P_NOWAIT ,"start",a);
						printf("err %d\n",errno);
							}
							break;*/
						case SDLK_SPACE:

							//TODO? // klavesa medzernik sa sprava ako pauza, co mozno nie je najvhodnejsie
							//pause(); //to asi vobec nie je dobry napad, ved medzernik sa moze nahodne stlacit bez problemov
							//ALT+Medzera minimalizovanie okna
							if(SDL_GetModState()&KMOD_ALT)
							{
								pause(pause_stop);//zastavi hru
								SDL_WM_IconifyWindow();
							};
							break;

						case SDLK_RETURN:	//ALT+ENTER zmena z okna na celu obrazovku a naopak
							if(SDL_GetModState()&KMOD_ALT)
							{
								SDL_WM_ToggleFullScreen(screen);
							};
							break;
						case SDLK_ESCAPE:
							if(stavHry!=stav_uvod) goto zaciatokNovejHry;//ak niesme v uvode tak na uvod inak pokracovat v konci
							{//koniec
								quit = 1;
								break;
							}
						case SDLK_F4:
							if(!(SDL_GetModState()&KMOD_ALT)) break;//spracovat ako koniec len ALT+F4
							{//koniec
								quit = 1;
								break;
							}

						case SDLK_q:
							if(!(SDL_GetModState()&(KMOD_SHIFT|KMOD_CTRL))) break;//spracovat ako koniec len SHIFT+Q alebo CTRL+Q
							{//koniec
								quit = 1;
								break;
							}
						case SDLK_p:
							pause();
							break;
						default:
							{
								for(int k=0; k<Max_Hracov; k++)
								{
									if(Panacik[k]->hra != clovek) continue;//ak za figurku k nehra clovek tak nie je obladana z klavesnice
			//						if(joyAopen && k==2) continue;//ak je otvoreny tak sa figurka neovlada klavesami? aj ked je joy nemusi ho pouzivat?
			//						if(joyBopen && k==3) continue;//ak je otvoreny tak sa figurka neovlada klavesami?
									if(sk == Panacik[k]->k_left)
									{
										Panacik[k]->pohybLeft = true;
										break;
									}
									else if(sk == Panacik[k]->k_right)
									{
										Panacik[k]->pohybRight = true;
										break;
									}
									else if(sk == Panacik[k]->k_up)
									{
										Panacik[k]->pohybUp = true;
										break;
									}
									else if(sk == Panacik[k]->k_down)
									{
										Panacik[k]->pohybDown = true;
										break;
									}
								};
								break;
							}

					}
					break;
					}
				case SDL_KEYUP:
					{
					const SDLKey sk=event.key.keysym.sym;
					for(int k=0, dalej=0 ; (k<Max_Hracov)&&(k==dalej); k++)
					{
						if(Panacik[k]->hra!=clovek) {dalej++;continue;}//ak za figurku k nehra clovek tak nie je obladana z klavesnice
						if(sk == Panacik[k]->k_left)
							Panacik[k]->pohybLeft = false;
						else if(sk == Panacik[k]->k_right)
							Panacik[k]->pohybRight = false;
						else if(sk == Panacik[k]->k_up)
							Panacik[k]->pohybUp = false;
						else if(sk == Panacik[k]->k_down)
							Panacik[k]->pohybDown = false;
						else dalej++;
					}
					break;
					}
				case SDL_JOYHATMOTION:
					{
						int ii=event.jhat.which + 2;
						if(ii<2 || ii>3) break;//ak sa niakym sposobom dostane ine cislo ako 2 alebo 3 (3. a 4. figurka)
						if(Panacik[ii]->hra != clovek) break;//ak za figurku ii nehra clovek tak nemoze byt ovladana joystickom 
						Panacik[ii]->pohybDown  = (event.jhat.value & SDL_HAT_DOWN)? 1:0;
						Panacik[ii]->pohybUp    = (event.jhat.value & SDL_HAT_UP)? 1:0;
						Panacik[ii]->pohybLeft  = (event.jhat.value & SDL_HAT_LEFT)? 1:0;
						Panacik[ii]->pohybRight = (event.jhat.value & SDL_HAT_RIGHT)? 1:0;
/*						switch(event.jhat.value)//which value
						{
							case 

						default:
							break;
						}*/
						break;
					}
				case SDL_ACTIVEEVENT:
					// ak sa prepnem do inej aplikacie alebo minimalizujem,... potom pauza
					// iba ak sa hra hra inak to nema zmysel TODO? mozno bude casom treba osetrit aj ine stavy ako len stav_hrasa?
					if(event.active.gain==0 && (event.active.state & (SDL_APPINPUTFOCUS | SDL_APPACTIVE)) && stavHry==stav_hrasa) 
						pause(pause_stop);//zastavi hru
					break;
				case SDL_QUIT:
					quit = 1;
					break;
				default:
					//printf("udalost %d\n",event.type);
					break;
			}
		} //koniec slucky vyhodnocujucej SDL udalosti

// vypocty		
		if(pauzaVhre==pause_run)
		{//ak je pauza tak sa nerobia ziadne vypocty, zatial
		//pocitac bude tahat figurkami za ktore hra
		//TODO?: toto je len najjednoduchsia logika
		//nepredpoklada nepriechodnost uzemi, ...
		for(int jc=0; jc<Max_Hracov; jc++)
		{
//logika pocitaca za figurku jc
			if(Panacik[jc]->hra==pocitac)
			{
				if(nahana==jc)
				{//ak tato figurka nahana
					int koho=0;
					int minv=-1;//najkratsia vzdialenost aka bola testovana
					int v;//vzdialenost k aktualne testovanej figurke
					for(int jn=0; jn<Max_Hracov; jn++)
					{//zistim ktora figurka je najblizsie
						if(jn==jc) continue;//nebudem nahanat sameho seba
						if(Panacik[jn]->hra==nehra) continue;//ak figurka jn nehra tak skusime dalsiu
						v=vzdialenostHracov(Panacik[jn],Panacik[nahana]);
						if(v<minv || minv==-1)
						{//ak je figurka jn blizsie ako pred nou testovane
							koho=jn;
							minv=v;
						};
					}
					//nastavim smer pohybu k najblizsej figurke
					//kedze velkym krokom sa neda nastavit presne na tu istu suradnicu x alebo y v bodoch ( co sposobuje poskakovanie figurky) staci priblizenie na jeden krok ? v rozmedzi  min_vzdialenost,ale v bodoch nie pixeloch
					//nastavujem tu ale posuvat sa bude vo viacnasobnom cykle, s cim treba ratat, alebo presunut toto riadenie do toho cykla
					//pohyb na osi X
					if(Panacik[koho]->poziciaX < Panacik[nahana]->poziciaX - Panacik[nahana]->rychlost*CYKLUS_PREPOCTU)
					{//ak je nahanana figurka vlavo
						Panacik[nahana]->pohybLeft=true;
						Panacik[nahana]->pohybRight=false;
					}else if(Panacik[koho]->poziciaX > Panacik[nahana]->poziciaX + Panacik[nahana]->rychlost*CYKLUS_PREPOCTU)
					{//ak je nahanana figurka vpravo
						Panacik[nahana]->pohybLeft=false;
						Panacik[nahana]->pohybRight=true;
					}else
					{//nahanana figurka je na rovnakom X ako nahanajuca
						Panacik[nahana]->pohybLeft=false;
						Panacik[nahana]->pohybRight=false;
					};
					//pohyb na osi Y
					if(Panacik[koho]->poziciaY < Panacik[nahana]->poziciaY - Panacik[nahana]->rychlost*CYKLUS_PREPOCTU )
					{//ak je nahanana figurka nad
						Panacik[nahana]->pohybUp=true;
						Panacik[nahana]->pohybDown=false;
					}else if(Panacik[koho]->poziciaY > Panacik[nahana]->poziciaY + Panacik[nahana]->rychlost*CYKLUS_PREPOCTU )
					{//ak je nahanana figurka pod
						Panacik[nahana]->pohybUp=false;
						Panacik[nahana]->pohybDown=true;
					}else
					{//nahanana figurka je na rovnakom Y ako nahanajuca
						Panacik[nahana]->pohybUp=false;
						Panacik[nahana]->pohybDown=false;
					};
				}else
				{//ak tato figurka uteka a zbiera predmety
					//TODO: treba zbierat predmety alebo utekat pred nahanajucim
					//TODO: predbezne sa len zastavy
					Panacik[jc]->pohybLeft=false;
					Panacik[jc]->pohybRight=false;
					Panacik[jc]->pohybUp=false;
					Panacik[jc]->pohybDown=false;
					//TODO: jednoduch logika vyhladavania by sa mozno dala urobyt aj cez riadky a stlpce v ktorych predmet lezi, co by mozno bolo rychlejsie ako cez vzdialenost????
					int np;//index najblizsieho predmetu
					int vnp;//vzdialenost najblizsieho predmetu
					int vcp;//vzdialenost aktualne testovaneho predmetu
					int vip;//vzdialenost ineho panacika od zaujimaveho predmetu
					int vnip;//vzdialenost najblizsieho predmetu ku ktoremu je niekto blizsie ako ja
					int nip;//index najblizsieho predmetu ku ktoremu je niekto blizsie ako ja
					do
					{
						vnp=-1;
						np=-1;
						nip=-1;
						vnip=-1;
						for(int jp=0; jp<Max_Predmetov;jp++)
						{//vyhladam najblizsi predmet
							if(/*predmety[jp].aky<predmet_zly &&*/ predmety[jp].aky!=predmet_nic)
							{//zaujimaju ma len dobre predmety
								vcp=Vzdialenost(*Panacik[jc],predmety[jp]);
								//ak niekto uteka za tym istym predmeom, je k predmetu blizsie a je reakcnom poli, tak ja za nim nepobezim 
								if(vcp<vnp || vnp==-1 )
								{//ak je vzdialenost testovaneho predmetu mensia ako posledna najmensia
									//alebo je to prvy predmet
									int ip;
									for(ip=0; ip<Max_Hracov; ip++)
									{
										if(Panacik[ip]->hra==nehra) continue;//ak figurka nehra tak skusime dalsiu
										if(ip==jc)
										{// sam seba nepovazujem za konkurenciu
											continue;
										//zakomentoval som to, lebo mozno bude stacit ak nebude utekat ani za predmetom, ku ktoremu bude blizsie nahanajuci a tym sa obratim od nahanajuceho
										//TODO: na utek pred nahanajucim to uplne nepostacuje(neuteka panicky, co je moznoze aj dobre, ked hraje viac hracov ale keby boli iba dvaja???)
										//DONE? dole som pridal podmienku pre utekanie k najblizsiemu hoc obsadenemu predmetu
										//}else	if(ip==nahana)
										//{//ak figurka nahana (ten mi predmet neuchyti ale pred nim by som mal utekat)
										//	//TODO: utekat pred nahanajucim
										//	continue;
										}else if(ip==nahana && obtiaznost<obtiaz_b)
										{//ak je nizka obtiaznot tak nebudem registrovat nahanajuceho
											continue;
										}else
										{//ak figurka pojeda tak zistim ci nie je k predmetu blizsie
											vip=Vzdialenost(*Panacik[ip],predmety[jp]);
											if(vip<reakcnaVzdialenost)
											{//ak je ina figurka v mojom reakcnom poli
												if(vcp>vip)
												{//ak je moja vzdialenost od predmetu vacsia ako ineho panacika
													vcp=-1;
													break;//predmet patri niekomu inemu a nema zmysel ho dalej testovat
												}
											}
										}
									};
									if(vcp != -1)
									{//
										vnp=vcp;//najblizsim predmetom je aktualny
										np=jp;
									}else
									{
										if(vcp<vnip || vnip==-1) 
										{//ak je aktualny predmet(hoc obsadeny) blizie ako predosly obsadeny predmet
											if(ip!=nahana || obtiaznost<obtiaz_c)
											{//posilneny ochrana, aby neutekal smerom k nahanajucemu
											// neuplne lebo ked zistim ze patri predmet niekomu tak dalej nekontrolujem(cize ak je tam ina figurka tak nezistim nahanajuceho)
											//TODO: lenze ked bol zahnany do rohu tak zastavy(je to neprirodzene),hoc kym nie su funkcne reakcne casy tak by utekat ani nemalo zmysel???
											//TODO:!  treba z pasce ujst, lenze nie systemom utekania za predmetom
											vnip=vcp;
											nip=jp;
											}
										}
									};
								}
							}
						}
					//TODO: ak niekto uteka za tym istym predmeom, je k predmetu blizsie a je reakcnom poli, tak ja za nim nepobezim 
					//      mozno to nestaci ja by som sa mal otocit n inu stranu hladat predmety tam
					}while(0);

					if(np<0 && nip>=0)
					{//ak nie je ku mne blizsie niaky predmet ako k ostatnym figurkam potom budem utekat za tym co je ku mne najblizsie aj ked je k niekomu inemu blizie ako ku mne
						np=nip;
					}
					if(np>=0)
					{// ak mam co nahanat
					 // zmena smeru k predmetu zaujmu
						if(predmety[np].poziciaX < Panacik[jc]->poziciaX - Panacik[jc]->rychlost*CYKLUS_PREPOCTU)
						{//ak je predmet vlavo
							Panacik[jc]->pohybLeft=true;
							Panacik[jc]->pohybRight=false;
						}else if(predmety[np].poziciaX > Panacik[jc]->poziciaX + Panacik[jc]->rychlost*CYKLUS_PREPOCTU)
						{//ak je predmet vpravo
							Panacik[jc]->pohybLeft=false;
							Panacik[jc]->pohybRight=true;
						}else
						{//predmet je na cca rovnakom X ako figurka
							Panacik[jc]->pohybLeft=false;
							Panacik[jc]->pohybRight=false;
						};
						//pohyb na osi Y
						if(predmety[np].poziciaY < Panacik[jc]->poziciaY - Panacik[jc]->rychlost*CYKLUS_PREPOCTU )
						{//ak je predmet nad
							Panacik[jc]->pohybUp=true;
							Panacik[jc]->pohybDown=false;
						}else if(predmety[np].poziciaY > Panacik[jc]->poziciaY + Panacik[jc]->rychlost*CYKLUS_PREPOCTU )
						{//ak je predmet pod
							Panacik[jc]->pohybUp=false;
							Panacik[jc]->pohybDown=true;
						}else
						{//predmet je na cca rovnakom Y ako figurka
							Panacik[jc]->pohybUp=false;
							Panacik[jc]->pohybDown=false;
						};
					};
				}
			}
		};

		

		//nastavenie pohybu figuriek po suradniciach podla smeru ktorym sa ma pohybovat
		//(podla klavesov)
		for(int j=0; j<Max_Hracov;j++)
		{
			if(Panacik[j]->hra==nehra) continue;
			Panacik[j]->pohybX = ((Panacik[j]->pohybLeft ? -1 : 0) + (Panacik[j]->pohybRight ? 1 : 0)) * Panacik[j]->rychlost;
			Panacik[j]->pohybY = ((Panacik[j]->pohybUp ? -1 : 0) + (Panacik[j]->pohybDown ? 1 : 0)) * Panacik[j]->rychlost;
			if(Panacik[j]->pohybX && Panacik[j]->pohybY)
			{//ak sa pohybuje po diagonale je pohyb v osiach prirodzene pomalsi
				Panacik[j]->pohybX *= 0.7071;
				Panacik[j]->pohybY *= 0.7071;
			}
		}
		
//pohyb figuriek a osetrenie stretov

		for(int n=0;n<CYKLUS_PREPOCTU;n++)
		{
			// zmena pozicie figuriek podla smeru a rychlosti
			for(int j=0; j<Max_Hracov;j++)
			{
				if(Panacik[j]->hra==nehra) continue;
			// zistenie ci sa moze pohybovat danym smerom
				//TODO: trba to dorobit, len kontrola stredu figurky mimo policka!!!
				static pozicia npx,npy;//static su aby sa nedeklarovali pri kazdom prechode -> uspora casu ????
				npx = Panacik[j]->poziciaX.hodnota + Panacik[j]->pohybX;
				npy = Panacik[j]->poziciaY.hodnota + Panacik[j]->pohybY;
				if(Panacik[j]->poziciaX.hodnotaPolicko.policko == npx.hodnotaPolicko.policko)
				{//ak sa v osi x nepresunie do ineho stlpca
					//zmena sa uskutocni po vsetkych testoch podmienok 
//					Panacik[j]->poziciaX.hodnota += Panacik[j]->pohybX * Panacik[j]->rychlost;
					
				}else
				{//panacik sa chce presunut do ineho stlpca 
					if(npx.hodnotaPolicko.policko<0 || npx.hodnotaPolicko.policko>=Max_Policiek)
					{//ak sa chce posunut mimo rozsah policiek
						Panacik[j]->pohybX=0;
					}else //ak je v ramci rozmerov pola policiek
					if(false)
					{
					}
				}
				if(Panacik[j]->poziciaY.hodnotaPolicko.policko == npy.hodnotaPolicko.policko)
				{//ak sa v osi y nepresunie do ineho riadku
					//zmena sa uskutocni po vsetkych testoch podmienok 
//					Panacik[j]->poziciaY.hodnota += Panacik[j]->pohybY * Panacik[j]->rychlost;
				}else
				{//panacik sa chce presunut do ineho riadku
					if(npy.hodnotaPolicko.policko<0 || npy.hodnotaPolicko.policko>=Max_Policiek)
					{//ak sa chce posunut mimo rozsah policiek
						Panacik[j]->pohybY=0;
					}else //ak je v ramci rozmerov pola policiek
					if(false)
					{
					}
				}
					
//				if(policko[npx.hodnotaPolicko.policko][npy.hodnotaPolicko.policko]
				//skutocna zmena pozicie
				Panacik[j]->poziciaX.hodnota += Panacik[j]->pohybX;
				Panacik[j]->poziciaY.hodnota += Panacik[j]->pohybY;
			};

			
			
			if(stavHry==stav_hrasa)//(nahanaSa)
			{
				for(int j=0; j<Max_Hracov;j++)
				{
					if(j==nahana) continue;//ten kto nahana nemoze chytit sam seba ani zbierat predmety
					if(Panacik[j]->hra==nehra) continue;// kto nehra ten nehra
			// zistenie ci ten kto nahana niekoho chytil
					if(vzdialenostHracov(Panacik[nahana],Panacik[j])<MIN_VZDIALENOST)
					{
						nahana=j;
						//TODO: rozhodenie vraj vobec nie je dobry napad??? ale co potom mozno na chvylu zastavit figurku????
						rozhod(Panacik[j]);
					}
			// zistenie ci niektora figurka chytila predmet
					for(int p=0;p<Max_Predmetov;p++)
					{
						if(predmety[p].aky == predmet_nic) continue;
						if(vzdialenostHracov(Panacik[j],&predmety[p]) < MIN_VZDIALENOST)
						{
							switch(predmety[p]/*.aky*/)
							{
								case predmet_zmrzlinaA:
								case predmet_zmrzlinaB:
								case predmet_zmrzlinaC:
								case predmet_nanuk:
									Panacik[j]->body++;
									myPlay(ham);
									break;
								case predmet_zmrzlinaV:
									Panacik[j]->body+=2;
									myPlay(ham);//liz?
									break;
/*								case predmet_spomalenie:
									break;*/
								default:
									break;
							}
//							if(predmety[p].aky<predmet_zly)
//							{//ak chytil dobry predmet
//								Panacik[j]->body++;
//							}else if(predmety[p]==predmet_spomalenie)
//							{
//								
//							}//else if() ....
							predmety[p].end();
						}
					};
				}	

			}else
			if(stavHry==stav_uvod)
			{
				for(int j=0; j<Max_Hracov;j++)
				{
					if(vzdialenostHracov(Panacik[j],(&(predmety[0])))<MIN_VZDIALENOST)
					{//ak sa niekto dotkne predmetu v strede
						stavHry=stav_hrasa;
						//ten kto nie je v kruhu ten nehra(pridal som, ze za toho bude hrat pocitac)
						int pp;//index pravdepodobnosti pri viacerych figurkach vzdialenych rovnako(vyuzity aj pre figurky ktore ovlada pocitac)
						for(int j=0; j<Max_Hracov;j++)
						{
							int nvk=0;//cislo figurky najviac vzdialenej od stredu kruhu

							int lv=0;//vzdialenost od stredu kruhu priebezne najvzdialenejsej figurky
							int cv;//vzdialenost aktualne figurki od stredu kruhu
							cv= Vzdialenost(*Panacik[j],uvodnykruh);
							if( cv > uvodnykruh.polomer) 
							{//ak je mimo kruhu
								Panacik[j]->hra=nehra;
								hraPanacikov--;
							}else
							{//ak je v kruhu
								//ten kto je najdalej od stredu nahana prvy
								if(lv < cv)
								{
									nvk=j;
									lv=cv;
									pp=2;//pravdepodobnost 1/(2)
								}else
								if(lv==cv)//ak je vzdialeny rovnako ako niaky iny
								{
									if((rand()%pp)==0)
									{
										nvk=j;
									}
									pp++;
								}
							}
							nahana=nvk;
						};
						//hrat budu vsetci 4 aj keby za ostatnych mal hrat pocitac - ked hraju iba 2 je to malo zabavne
						if(hraPanacikov<4)// hraPanacikov<2 ak chcem pridat pocitac iba ak by mal hrat iba 1 hrac
						{
							for(int j=0;j<Max_Hracov;j++)
							{
								if(Panacik[j]->hra==nehra)
								{
									Panacik[j]->hra=pocitac;
									if(rand()%pp==0) {nahana=j;};
									pp++;
									hraPanacikov++;
									//break;//ak chcem aby hral pocitac iba za jednu figurku

								};
							};
						};
					}
				}	
			}

		};	//koniec cyklu 4xprepocet

		//pridavanie predmetov na plochu
		if(stavHry==stav_hrasa)
		{
			for(int p=0;p<Max_Predmetov;p++)
			{
				//odpocitanie zobrazenia predmetov
				if(predmety[p].timeleft && !predmety[p].tick())
				{//ak predmet existoval ale po .tick uz nie
					//TODO? zvuk zmiznuteho predmetu
					//myPlay(zvuk_lpredmet);
				};
			};
			// prida na plochu novy nahodny predmet
			static int novy_predmet=0;
			if(++novy_predmet>10)
			{
				//TODO? zvuk noveho predmetu
				//myPlay(zvuk_npredmet);
				pridajPredmet(predmety,rand()%Max_Policiek,rand()%Max_Policiek);//TODO: treba vykonat kontrolu policka, ci moze obsahovat predmet
				novy_predmet=0;
			};
		};

		}else //koniec podmienky ci nie je pauza v ktorej sa nerobia ziadne vypocty
		{//ak je hra zapauzovana vynulujem pohyb vsetky figurkam
			// vynulovanie so chcel aby sa v pauze nemenil stav figuriek a tym aby sa nekreslilonieco nove, ale nulovanie stavu figuriek pocas pauzy by znemoznilo plynule pokracovat po uvolneni z pauzy (jeto dolezite ???)
			//for(int j=0; j<Max_Hracov;j++)
			//{
			//	Panacik[j]->pohybLeft=false; 
			//  atd....
			//};

		};	//koniec podmienky ci nie je pauza 
		
// vykreslovanie

		//TODO: pocas pauzy by bolo dobre iba udrziavat posledny stav obrazovky a nie stale prekreslovat (niako zosnimat obrazovku 	alebo co)
		//TODO: to by umoznilo aby sa pocas pauzy nemenila obrazovka, lebo reakcie na klavesy nemozem pocas pauzy uplne vyradit(nemozem vyradit reakciu na pustenie klavesy, aby pri pokracovani nebezali figurky do zblbnutia)
		//		reakcie na stlacenie by sa dali potlacit, ale bud vsetko alebo nic???? po pusteni klavesy sa vykreslovana obrazovka takmer nemeni takze, by to mohlo stacit idem na to!
		//		tadialto cesta nevedie, lebo to neumoznuje plynuly prechod z pauzy!!!
		//vykreslenie na obrazovku


		static bool isscrpause=false;
//		static SDL_Surface* scrpause=NULL;
		if(pauzaVhre==pause_stop)
		{//ak je pauza tak to patricne znazornim na obrazovke
			if(!isscrpause)
			{
//			  scrpause = SDL_DisplayFormat(screen);
			  isscrpause = true;
			
				SDL_Surface *sprava;
				sprava=textToRasterSurface(i18n("Game paused! Press 'P' to continue!"),255,255,0);
				simBlit(sprava,(screen->w-sprava->w)/2,(screen->h-sprava->h)/2,screen);
				SDL_FreeSurface(sprava);
			};
//			simBlit(scrpause,0,0,screen);

			//TODO: zobrazenie ze je pauza treba prerobyt, velky blikajuci nadpis v strede
//TODO: cele je to len na skusku, treba upravit aj textToRasterSurface
//TODO: strasne to spomaluje?
//			SDL_Surface *sprava;
//			sprava=textToRasterSurface(i18n("Game paused! Press 'P' to continue!"),255,255,0);
//			simBlit(sprava,(screen->w-sprava->w)/2,(screen->h-sprava->h)/2,screen);
//			SDL_FreeSurface(sprava);
		}else
		{//normalne prekreslovanie pocas behu hry
			if(isscrpause)
			{
				isscrpause = false;
//				SDL_FreeSurface(scrpause);
			};
  		simBlit(obr_celepozadie,0,0,screen);		

  /*
  		//vymazanie obrazovky
  		SDL_FillRect(screen,&screen->clip_rect,c_obloha);
  		//vykreslenie pozadia
  		simBlit(pozadie,0,60,screen);		
  		//vykreslenie policok
  		for(int m=0; m<Max_Policiek; m++)
  			for(int n=0; n<Max_Policiek; n++)
  			{
  //				if(!policko[n][m]) {Draw_FillRect(screen,n*32,m*16+Max_Policiek*8,32,16,c_policko);Draw_Rect(screen,n*32,m*16+Max_Policiek*8,32,16,c_ramik);}
  				switch(policko[n][m])
  				{
  					case 0:
  						{
  							simBlit(lp,n*32,m*16+posunutiey,screen);
  							break;
  						}
  					default:
  						break;
  				}
  			}
  */
  		if(stavHry==stav_uvod)//ak je uvod nakreslime koleso
  		{
  			//TODO: SDL_draw kresli elipsu inych rozmerov ako SDL_gfx?!?!?
  //			Draw_Ellipse(screen,uvodnykruh.poziciaX.hodnotaPixelX.pixel,uvodnykruh.poziciaY.hodnotaPixelY.pixel+posunutiey,uvodnykruh.polomer,uvodnykruh.polomer/2, c_red);
  			aaellipseColor(screen,uvodnykruh.poziciaX.hodnotaPixelX.pixel,uvodnykruh.poziciaY.hodnotaPixelY.pixel+posunutiey,uvodnykruh.polomer,uvodnykruh.polomer/2, 0xff0000ff);
  //			aaellipseColor(screen,uvodnykruh.poziciaX.hodnotaPixelX.pixel,uvodnykruh.poziciaY.hodnotaPixelY.pixel+posunutiey,uvodnykruh.polomer/2,uvodnykruh.polomer, 0xff0000ff);
  			//zobrazime spravu, ze kto chce hrat nech bezi do kruhu
  //TODO: cele je to len na skusku, treba upravit aj textToRasterSurface
  //TODO: strasne to spomaluje
  			SDL_Surface *sprava;
  			sprava=textToRasterSurface(i18n("If you wont play go inside circle and eat ice!"),255,255,0);
  			simBlit(sprava,0,0,screen);
  			SDL_FreeSurface(sprava);
  			
  		}else
  		if(stavHry==stav_hrasa)
  		{// ak sa hra vykreslime body
  //TODO: cele je to len na skusku, treba upravit aj textToRasterSurface
  //TODO: strasne to spomaluje
  			SDL_Surface *body;
  			char txtbody[5];
  			sprintf(txtbody,"%3d",Panacik[0]->body);
  			body=textToRasterSurface(txtbody,Panacik[0]->farba.r,Panacik[0]->farba.g,Panacik[0]->farba.b);
  			simBlit(body,0,0,screen);
  			SDL_FreeSurface(body);
  			
  			sprintf(txtbody,"%3d",Panacik[1]->body);
  			body=textToRasterSurface(txtbody,Panacik[1]->farba.r,Panacik[1]->farba.g,Panacik[1]->farba.b);
  			simBlit(body,600,20,screen);
  			SDL_FreeSurface(body);

  			sprintf(txtbody,"%3d",Panacik[2]->body);
  			body=textToRasterSurface(txtbody,Panacik[2]->farba.r,Panacik[2]->farba.g,Panacik[2]->farba.b);
  			simBlit(body,600,0,screen);
  			SDL_FreeSurface(body);

  			sprintf(txtbody,"%3d",Panacik[3]->body);
  			body=textToRasterSurface(txtbody,Panacik[3]->farba.r,Panacik[3]->farba.g,Panacik[3]->farba.b);
  			simBlit(body,0,20,screen);
  			SDL_FreeSurface(body);
  			
  		};

  		for( int k=0; k<Max_Objektov; k++)//vymaze Z buffer
  		{
  			bufferZ[k].obsadene = false;
  			bufferZ[k].obsah= ztag_pocet;
  		}

  		for( int i=0; i<Max_Hracov; i++)//naplni Z buffer figurkami
  		{
  			int h;
  			h=0;
  			for(int k=0;k<Max_Hracov; k++)
  			{
  				if(Panacik[i]->poziciaY.hodnota > Panacik[k]->poziciaY.hodnota) h++;
  			}
  			for(int l=0;l<Max_Predmetov; l++)
  			{
  				if(Panacik[i]->poziciaY.hodnota > predmety[l].poziciaY.hodnota) h++;
  			}
  			while(bufferZ[h].obsadene) {h++;};

  			bufferZ[h].cislo=i;
  			bufferZ[h].obsadene=true;
  			bufferZ[h].obsah=ztag_figurka;
  		}
  		
  		for(int p=0; p<Max_Predmetov; p++)//naplni Z buffer predmetmi (aj tymi co sa nebudu vykreslovat, lebo obsahuju nic)
  		{
  			int h;
  			h=0;
  			for(int k=0;k<Max_Hracov; k++)
  			{
  				if(predmety[p].poziciaY.hodnota > Panacik[k]->poziciaY.hodnota) h++;
  			}
  			for(int l=0;l<Max_Predmetov; l++)

  			{
  				if(predmety[p].poziciaY.hodnota > predmety[l].poziciaY.hodnota) h++;
  			}
  			while(bufferZ[h].obsadene) {h++;};
  			bufferZ[h].cislo=p;
  			bufferZ[h].obsadene=true;
  			bufferZ[h].obsah=ztag_predmet;
  		}


  		for( int l=0; l<Max_Objektov; l++)	// vykresli objekty podla Z buffra
  		{
  			if(bufferZ[l].obsadene)
  			{//ak je polozka Z buffra platna - len pre istotu, teraz to neni treba -> mohol by sa usetrit cas?
  				switch(bufferZ[l].obsah)
  				{
  				case ztag_figurka:
  					{
  						int ii;
  						ii = bufferZ[l].cislo;
  						if(Panacik[ii]->hra==nehra) break;//ak panacik nehra tak ho ani nebudeme kreslit
  						if(ii==nahana && stavHry==stav_hrasa)
  						{//ak nahana nakreslime pod figurku biely kruh s farebnym okrajom(kriz)
  							//TODO: co s tym antialiasingom?
  							//Draw_FillEllipse(screen,Panacik[ii]->poziciaX.hodnotaPixelX.pixel, Panacik[ii]->poziciaY.hodnotaPixelY.pixel+posunutiey, MIN_VZDIALENOST>>1, MIN_VZDIALENOST>>2, c_white);

  							filledEllipseColor(screen,Panacik[ii]->poziciaX.hodnotaPixelX.pixel, Panacik[ii]->poziciaY.hodnotaPixelY.pixel+posunutiey, MIN_VZDIALENOST>>1, MIN_VZDIALENOST>>2, 0xffffffff);
  //							simBlit(podkriz[ii],(Panacik[ii]->poziciaX.hodnotaPixelX.pixel - (podkriz[ii]->w/2)), (Panacik[ii]->poziciaY.hodnotaPixelY.pixel+(posunutiey) - (podkriz[ii]->h/2)),screen);
  							//Draw_Ellipse(screen,Panacik[ii]->poziciaX.hodnotaPixelX.pixel, Panacik[ii]->poziciaY.hodnotaPixelY.pixel+posunutiey, MIN_VZDIALENOST>>1, MIN_VZDIALENOST>>2,FarbyHracov[ii]);
  							aaellipseRGBA(screen,Panacik[ii]->poziciaX.hodnotaPixelX.pixel, Panacik[ii]->poziciaY.hodnotaPixelY.pixel+posunutiey, (MIN_VZDIALENOST>>1), (MIN_VZDIALENOST>>2),Panacik[ii]->farba.r,Panacik[ii]->farba.g,Panacik[ii]->farba.b,0xff);
  						}else
  						{//ak nenahana nakreslime pod figurku kruh
  							//TODO: co s tym antialiasingom?
  							//Draw_FillEllipse(screen,Panacik[ii]->poziciaX.hodnotaPixelX.pixel, Panacik[ii]->poziciaY.hodnotaPixelY.pixel+posunutiey, MIN_VZDIALENOST>>1, MIN_VZDIALENOST>>2,FarbyHracov[ii]);
  							filledEllipseRGBA(screen,Panacik[ii]->poziciaX.hodnotaPixelX.pixel, Panacik[ii]->poziciaY.hodnotaPixelY.pixel+posunutiey, (MIN_VZDIALENOST>>1), (MIN_VZDIALENOST>>2),Panacik[ii]->farba.r,Panacik[ii]->farba.g,Panacik[ii]->farba.b,0xff);
  							aaellipseRGBA(screen,Panacik[ii]->poziciaX.hodnotaPixelX.pixel, Panacik[ii]->poziciaY.hodnotaPixelY.pixel+posunutiey, (MIN_VZDIALENOST>>1), (MIN_VZDIALENOST>>2),Panacik[ii]->farba.r,Panacik[ii]->farba.g,Panacik[ii]->farba.b,0xff);
  						};
  						SDL_Surface *animobr;
  						animobr=Panacik[ii]->animobr();
  						simBlit(animobr,(Panacik[ii]->poziciaX.hodnotaPixelX.pixel - (animobr->w/2)), (Panacik[ii]->poziciaY.hodnotaPixelY.pixel+(posunutiey) - (animobr->h-1)),screen);
  						break;
  					};
  				case ztag_predmet:
  					{
  						int ii;
  						ii = bufferZ[l].cislo;
  						SDL_Surface *animobr;
  						switch(predmety[ii].aky)
  						{
  						case predmet_zmrzlinaA:
  							animobr=obr_zmrzlinaA;
  							break;
  						case predmet_zmrzlinaB:
  							animobr=obr_zmrzlinaB;
  							break;
  						case predmet_zmrzlinaC:
  							animobr=obr_zmrzlinaC;
  							break;
  						case predmet_zmrzlinaV:
  							animobr=obr_zmrzlinaV;
  							break;
  						case predmet_nanuk:
  							animobr=obr_nanuk;
  							break;
  /*						case predmet_spomalenie:
  							animobr=obr_spomalenie;
  							break;*/
  						default:
  							animobr=NULL;
  						};
  						if(animobr)
  						{
  							simBlit(animobr,(predmety[ii].poziciaX.hodnotaPixelX.pixel - (animobr->w/2)), (predmety[ii].poziciaY.hodnotaPixelY.pixel+posunutiey - (animobr->h)),screen);
  						};
  						break;

  					};
  				default:
  					{
  						break;
  					};
  				};
  			};
  		};//koniec cyklu v ktorom sa postupne vykresluju vsetky objekty zo Z buffra

  		//pokus s elipsami kto ake kresli
  //		Draw_FillEllipse(screen,100,200,8,4,c_red);
  //		filledEllipseColor(screen,200,200,7,3,0xff0000ff);
  //		aaellipseColor(screen,300,200,7,3,0xff0000ff);

		};		
		//SDL_Flip(screen);
//		SDL_UpdateRect(screen,0,0,0,0);//neviem ci prekreslovat tu alebo az po delay???
		Sint32 d;
		d=100-(SDL_GetTicks()-t);
//		printf("delay %d\n", d );
//		printf("gt %d\n", SDL_GetTicks() );
//		printf("t %d\n", t );
		if(d>0)
		{
			SDL_Delay(d);
//		static int pd=0,pdc=0;
//		pdc++;
//		pd+=d;
//		printf("priem d %d\n",pd/pdc);
		};
		t=SDL_GetTicks();
		
		SDL_UpdateRect(screen,0,0,0,0);
		
//		static int fps=0;
//		static Uint32 ot=SDL_GetTicks();
//		fps++;
//		if(ot+1000<SDL_GetTicks())
//		{	
//			ot=SDL_GetTicks();
//			printf("%d\n", fps );
//			fps=0;
//		}

	}; //koniec slucky while(!quit)


//	SDL_Quit();

#ifdef SPONZOR

	SDL_Surface *reklama;
#include "ruka.xbm"
#include "ruka_mask.xbm"
	enum aky_cur {cur_sipka,cur_ruka};

	SDL_Cursor * ruka=SDL_CreateCursor((unsigned char *)ruka_bits, ruka_mask_bits, ruka_width, ruka_height, ruka_x_hot, ruka_y_hot);
	SDL_Cursor * sipka=SDL_GetCursor();
	aky_cur akual_cur=cur_sipka;
	bool koniecreklamy=false;

	reklama=SDL_LoadBMP("reklama.bmp");
	SDL_FillRect(screen,&screen->clip_rect,c_black);
	if(reklama)

	{
		simBlit(reklama,(screen->w-reklama->w)/2,(screen->h-reklama->h)/2,screen);
		SDL_ShowCursor(SDL_ENABLE);
		SDL_UpdateRect(screen,0,0,0,0);
		t=SDL_GetTicks();
//		for(int ec=0;ec<300;ec++)
		//{
		SDL_Rect link={85,325,465,35};
		while(t+8000>SDL_GetTicks() && !koniecreklamy)
		{
			while( SDL_PollEvent( &event ) )
			{
				switch( event.type )
				{
				case SDL_MOUSEMOTION:
					{
						if(event.motion.x>link.x && event.motion.x<link.x+link.w && event.motion.y>link.y && event.motion.y<link.y+link.h)
						{
							if(akual_cur!=cur_ruka)
							{
								SDL_SetCursor(ruka);
								akual_cur=cur_ruka;
							}
						}else
						{
							if(akual_cur!=cur_sipka)
							{
								SDL_SetCursor(sipka);
								akual_cur=cur_sipka;
							}
						}
					}
					break;
				case SDL_MOUSEBUTTONDOWN:
					if(event.button.x>link.x && event.button.x<link.x+link.w && event.button.y>link.y && event.button.y<link.y+link.h)
					{
						//TODO: niako otvorit www stranku!!!!!!!
						//system("START sponzor.htm");
#if defined(_WIN32)
					ShellExecute(NULL, NULL, "sponzor.url", NULL, NULL, SW_SHOWNORMAL);
/*						char *a[2];
						a[0]="sponzor.htm";
						a[1]=NULL;

						int r=_spawnv(_P_NOWAIT ,"start" ,a);
						printf("err %d\n",errno);*/
#else //elif defined(linux)
//						int pid=fork();
	//					if(pid==0)
		//				{
//							execvp ("START", "START sponzor.htm");
			//			}
//						spawnlp (P_NOWAIT, "prog", "prog", "url", NULL);
#endif 
        koniecreklamy=true;
					};
					break;
				default:
					break;
				}
			}
			SDL_Delay(10);
		}
	}
#endif //SPONZOR
//	printf("\n%s\n",setlocale( LC_ALL, NULL ));
	//printf(i18n("\nThis game was developed by support our sponsor: %s\n"),SPONZOR);
	printf(i18n("\nThank You for playing this game!\n"));
	

	return EXIT_SUCCESS;
}
